/**
 * Copyright (c) 2021 Contributors to the Eclipse Foundation
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Do not edit: This file is generated by Xtext
 */
grammar InternalSetting;

options {
	superClass=AbstractInternalContentAssistParser;
}

@lexer::header {
package org.eclipse.lsat.setting.teditor.ide.contentassist.antlr.internal;

// Hack: Use our own Lexer superclass by means of import. 
// Currently there is no other way to specify the superclass for the lexer.
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.Lexer;
}

@parser::header {
package org.eclipse.lsat.setting.teditor.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.eclipse.lsat.setting.teditor.services.SettingGrammarAccess;

}
@parser::members {
	private SettingGrammarAccess grammarAccess;

	public void setGrammarAccess(SettingGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}

	@Override
	protected Grammar getGrammar() {
		return grammarAccess.getGrammar();
	}

	@Override
	protected String getValueForTokenName(String tokenName) {
		return tokenName;
	}
}

// Entry rule entryRuleSettings
entryRuleSettings
:
{ before(grammarAccess.getSettingsRule()); }
	 ruleSettings
{ after(grammarAccess.getSettingsRule()); } 
	 EOF 
;

// Rule Settings
ruleSettings 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getSettingsAccess().getGroup()); }
		(rule__Settings__Group__0)
		{ after(grammarAccess.getSettingsAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleImport
entryRuleImport
:
{ before(grammarAccess.getImportRule()); }
	 ruleImport
{ after(grammarAccess.getImportRule()); } 
	 EOF 
;

// Rule Import
ruleImport 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getImportAccess().getGroup()); }
		(rule__Import__Group__0)
		{ after(grammarAccess.getImportAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRulePhysicalSettings
entryRulePhysicalSettings
:
{ before(grammarAccess.getPhysicalSettingsRule()); }
	 rulePhysicalSettings
{ after(grammarAccess.getPhysicalSettingsRule()); } 
	 EOF 
;

// Rule PhysicalSettings
rulePhysicalSettings 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getPhysicalSettingsAccess().getGroup()); }
		(rule__PhysicalSettings__Group__0)
		{ after(grammarAccess.getPhysicalSettingsAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleMotionSettingsMapEntry
entryRuleMotionSettingsMapEntry
:
{ before(grammarAccess.getMotionSettingsMapEntryRule()); }
	 ruleMotionSettingsMapEntry
{ after(grammarAccess.getMotionSettingsMapEntryRule()); } 
	 EOF 
;

// Rule MotionSettingsMapEntry
ruleMotionSettingsMapEntry 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getMotionSettingsMapEntryAccess().getGroup()); }
		(rule__MotionSettingsMapEntry__Group__0)
		{ after(grammarAccess.getMotionSettingsMapEntryAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleMotionSettings
entryRuleMotionSettings
:
{ before(grammarAccess.getMotionSettingsRule()); }
	 ruleMotionSettings
{ after(grammarAccess.getMotionSettingsRule()); } 
	 EOF 
;

// Rule MotionSettings
ruleMotionSettings 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getMotionSettingsAccess().getGroup()); }
		(rule__MotionSettings__Group__0)
		{ after(grammarAccess.getMotionSettingsAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleProfileSettingsMapEntry
entryRuleProfileSettingsMapEntry
:
{ before(grammarAccess.getProfileSettingsMapEntryRule()); }
	 ruleProfileSettingsMapEntry
{ after(grammarAccess.getProfileSettingsMapEntryRule()); } 
	 EOF 
;

// Rule ProfileSettingsMapEntry
ruleProfileSettingsMapEntry 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getProfileSettingsMapEntryAccess().getGroup()); }
		(rule__ProfileSettingsMapEntry__Group__0)
		{ after(grammarAccess.getProfileSettingsMapEntryAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleLocationSettingsMapEntry
entryRuleLocationSettingsMapEntry
:
{ before(grammarAccess.getLocationSettingsMapEntryRule()); }
	 ruleLocationSettingsMapEntry
{ after(grammarAccess.getLocationSettingsMapEntryRule()); } 
	 EOF 
;

// Rule LocationSettingsMapEntry
ruleLocationSettingsMapEntry 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getLocationSettingsMapEntryAccess().getGroup()); }
		(rule__LocationSettingsMapEntry__Group__0)
		{ after(grammarAccess.getLocationSettingsMapEntryAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleDistanceSettingsMapEntry
entryRuleDistanceSettingsMapEntry
:
{ before(grammarAccess.getDistanceSettingsMapEntryRule()); }
	 ruleDistanceSettingsMapEntry
{ after(grammarAccess.getDistanceSettingsMapEntryRule()); } 
	 EOF 
;

// Rule DistanceSettingsMapEntry
ruleDistanceSettingsMapEntry 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getDistanceSettingsMapEntryAccess().getGroup()); }
		(rule__DistanceSettingsMapEntry__Group__0)
		{ after(grammarAccess.getDistanceSettingsMapEntryAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleTimingSettingsMapEntry
entryRuleTimingSettingsMapEntry
:
{ before(grammarAccess.getTimingSettingsMapEntryRule()); }
	 ruleTimingSettingsMapEntry
{ after(grammarAccess.getTimingSettingsMapEntryRule()); } 
	 EOF 
;

// Rule TimingSettingsMapEntry
ruleTimingSettingsMapEntry 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getTimingSettingsMapEntryAccess().getGroup()); }
		(rule__TimingSettingsMapEntry__Group__0)
		{ after(grammarAccess.getTimingSettingsMapEntryAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleMotionProfileSettings
entryRuleMotionProfileSettings
:
{ before(grammarAccess.getMotionProfileSettingsRule()); }
	 ruleMotionProfileSettings
{ after(grammarAccess.getMotionProfileSettingsRule()); } 
	 EOF 
;

// Rule MotionProfileSettings
ruleMotionProfileSettings 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getMotionProfileSettingsAccess().getGroup()); }
		(rule__MotionProfileSettings__Group__0)
		{ after(grammarAccess.getMotionProfileSettingsAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleMotionArgumentsMapEntry
entryRuleMotionArgumentsMapEntry
:
{ before(grammarAccess.getMotionArgumentsMapEntryRule()); }
	 ruleMotionArgumentsMapEntry
{ after(grammarAccess.getMotionArgumentsMapEntryRule()); } 
	 EOF 
;

// Rule MotionArgumentsMapEntry
ruleMotionArgumentsMapEntry 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getMotionArgumentsMapEntryAccess().getGroup()); }
		(rule__MotionArgumentsMapEntry__Group__0)
		{ after(grammarAccess.getMotionArgumentsMapEntryAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRulePhysicalLocation
entryRulePhysicalLocation
:
{ before(grammarAccess.getPhysicalLocationRule()); }
	 rulePhysicalLocation
{ after(grammarAccess.getPhysicalLocationRule()); } 
	 EOF 
;

// Rule PhysicalLocation
rulePhysicalLocation 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getPhysicalLocationAccess().getAlternatives()); }
		(rule__PhysicalLocation__Alternatives)
		{ after(grammarAccess.getPhysicalLocationAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleTiming
entryRuleTiming
:
{ before(grammarAccess.getTimingRule()); }
	 ruleTiming
{ after(grammarAccess.getTimingRule()); } 
	 EOF 
;

// Rule Timing
ruleTiming 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getTimingAccess().getAlternatives()); }
		(rule__Timing__Alternatives)
		{ after(grammarAccess.getTimingAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleFixedValue
entryRuleFixedValue
:
{ before(grammarAccess.getFixedValueRule()); }
	 ruleFixedValue
{ after(grammarAccess.getFixedValueRule()); } 
	 EOF 
;

// Rule FixedValue
ruleFixedValue 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getFixedValueAccess().getValueExpAssignment()); }
		(rule__FixedValue__ValueExpAssignment)
		{ after(grammarAccess.getFixedValueAccess().getValueExpAssignment()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleArray
entryRuleArray
:
{ before(grammarAccess.getArrayRule()); }
	 ruleArray
{ after(grammarAccess.getArrayRule()); } 
	 EOF 
;

// Rule Array
ruleArray 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getArrayAccess().getGroup()); }
		(rule__Array__Group__0)
		{ after(grammarAccess.getArrayAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleTriangularDistribution
entryRuleTriangularDistribution
:
{ before(grammarAccess.getTriangularDistributionRule()); }
	 ruleTriangularDistribution
{ after(grammarAccess.getTriangularDistributionRule()); } 
	 EOF 
;

// Rule TriangularDistribution
ruleTriangularDistribution 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getTriangularDistributionAccess().getGroup()); }
		(rule__TriangularDistribution__Group__0)
		{ after(grammarAccess.getTriangularDistributionAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRulePertDistribution
entryRulePertDistribution
:
{ before(grammarAccess.getPertDistributionRule()); }
	 rulePertDistribution
{ after(grammarAccess.getPertDistributionRule()); } 
	 EOF 
;

// Rule PertDistribution
rulePertDistribution 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getPertDistributionAccess().getGroup()); }
		(rule__PertDistribution__Group__0)
		{ after(grammarAccess.getPertDistributionAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleNormalDistribution
entryRuleNormalDistribution
:
{ before(grammarAccess.getNormalDistributionRule()); }
	 ruleNormalDistribution
{ after(grammarAccess.getNormalDistributionRule()); } 
	 EOF 
;

// Rule NormalDistribution
ruleNormalDistribution 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getNormalDistributionAccess().getGroup()); }
		(rule__NormalDistribution__Group__0)
		{ after(grammarAccess.getNormalDistributionAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEnumeratedDistribution
entryRuleEnumeratedDistribution
:
{ before(grammarAccess.getEnumeratedDistributionRule()); }
	 ruleEnumeratedDistribution
{ after(grammarAccess.getEnumeratedDistributionRule()); } 
	 EOF 
;

// Rule EnumeratedDistribution
ruleEnumeratedDistribution 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEnumeratedDistributionAccess().getGroup()); }
		(rule__EnumeratedDistribution__Group__0)
		{ after(grammarAccess.getEnumeratedDistributionAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleDeclaration
entryRuleDeclaration
:
{ before(grammarAccess.getDeclarationRule()); }
	 ruleDeclaration
{ after(grammarAccess.getDeclarationRule()); } 
	 EOF 
;

// Rule Declaration
ruleDeclaration 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getDeclarationAccess().getGroup()); }
		(rule__Declaration__Group__0)
		{ after(grammarAccess.getDeclarationAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleExpression
entryRuleExpression
:
{ before(grammarAccess.getExpressionRule()); }
	 ruleExpression
{ after(grammarAccess.getExpressionRule()); } 
	 EOF 
;

// Rule Expression
ruleExpression 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getExpressionAccess().getPlusOrMinusParserRuleCall()); }
		rulePlusOrMinus
		{ after(grammarAccess.getExpressionAccess().getPlusOrMinusParserRuleCall()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRulePlusOrMinus
entryRulePlusOrMinus
:
{ before(grammarAccess.getPlusOrMinusRule()); }
	 rulePlusOrMinus
{ after(grammarAccess.getPlusOrMinusRule()); } 
	 EOF 
;

// Rule PlusOrMinus
rulePlusOrMinus 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getPlusOrMinusAccess().getGroup()); }
		(rule__PlusOrMinus__Group__0)
		{ after(grammarAccess.getPlusOrMinusAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleMulOrDiv
entryRuleMulOrDiv
:
{ before(grammarAccess.getMulOrDivRule()); }
	 ruleMulOrDiv
{ after(grammarAccess.getMulOrDivRule()); } 
	 EOF 
;

// Rule MulOrDiv
ruleMulOrDiv 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getMulOrDivAccess().getGroup()); }
		(rule__MulOrDiv__Group__0)
		{ after(grammarAccess.getMulOrDivAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRulePrimary
entryRulePrimary
:
{ before(grammarAccess.getPrimaryRule()); }
	 rulePrimary
{ after(grammarAccess.getPrimaryRule()); } 
	 EOF 
;

// Rule Primary
rulePrimary 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getPrimaryAccess().getAlternatives()); }
		(rule__Primary__Alternatives)
		{ after(grammarAccess.getPrimaryAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleAtomic
entryRuleAtomic
:
{ before(grammarAccess.getAtomicRule()); }
	 ruleAtomic
{ after(grammarAccess.getAtomicRule()); } 
	 EOF 
;

// Rule Atomic
ruleAtomic 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getAtomicAccess().getAlternatives()); }
		(rule__Atomic__Alternatives)
		{ after(grammarAccess.getAtomicAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEBigDecimal
entryRuleEBigDecimal
:
{ before(grammarAccess.getEBigDecimalRule()); }
	 ruleEBigDecimal
{ after(grammarAccess.getEBigDecimalRule()); } 
	 EOF 
;

// Rule EBigDecimal
ruleEBigDecimal 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEBigDecimalAccess().getGroup()); }
		(rule__EBigDecimal__Group__0)
		{ after(grammarAccess.getEBigDecimalAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleIID
entryRuleIID
:
{ before(grammarAccess.getIIDRule()); }
	 ruleIID
{ after(grammarAccess.getIIDRule()); } 
	 EOF 
;

// Rule IID
ruleIID 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getIIDAccess().getAlternatives()); }
		(rule__IID__Alternatives)
		{ after(grammarAccess.getIIDAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleResourceQualifiedName
entryRuleResourceQualifiedName
:
{ before(grammarAccess.getResourceQualifiedNameRule()); }
	 ruleResourceQualifiedName
{ after(grammarAccess.getResourceQualifiedNameRule()); } 
	 EOF 
;

// Rule ResourceQualifiedName
ruleResourceQualifiedName 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getResourceQualifiedNameAccess().getGroup()); }
		(rule__ResourceQualifiedName__Group__0)
		{ after(grammarAccess.getResourceQualifiedNameAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPhysicalLocationAccess().getGroup_0()); }
		(rule__PhysicalLocation__Group_0__0)
		{ after(grammarAccess.getPhysicalLocationAccess().getGroup_0()); }
	)
	|
	(
		{ before(grammarAccess.getPhysicalLocationAccess().getGroup_1()); }
		(rule__PhysicalLocation__Group_1__0)
		{ after(grammarAccess.getPhysicalLocationAccess().getGroup_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Timing__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getTimingAccess().getFixedValueParserRuleCall_0()); }
		ruleFixedValue
		{ after(grammarAccess.getTimingAccess().getFixedValueParserRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getTimingAccess().getArrayParserRuleCall_1()); }
		ruleArray
		{ after(grammarAccess.getTimingAccess().getArrayParserRuleCall_1()); }
	)
	|
	(
		{ before(grammarAccess.getTimingAccess().getTriangularDistributionParserRuleCall_2()); }
		ruleTriangularDistribution
		{ after(grammarAccess.getTimingAccess().getTriangularDistributionParserRuleCall_2()); }
	)
	|
	(
		{ before(grammarAccess.getTimingAccess().getPertDistributionParserRuleCall_3()); }
		rulePertDistribution
		{ after(grammarAccess.getTimingAccess().getPertDistributionParserRuleCall_3()); }
	)
	|
	(
		{ before(grammarAccess.getTimingAccess().getNormalDistributionParserRuleCall_4()); }
		ruleNormalDistribution
		{ after(grammarAccess.getTimingAccess().getNormalDistributionParserRuleCall_4()); }
	)
	|
	(
		{ before(grammarAccess.getTimingAccess().getEnumeratedDistributionParserRuleCall_5()); }
		ruleEnumeratedDistribution
		{ after(grammarAccess.getTimingAccess().getEnumeratedDistributionParserRuleCall_5()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PlusOrMinus__Alternatives_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPlusOrMinusAccess().getGroup_1_0_0()); }
		(rule__PlusOrMinus__Group_1_0_0__0)
		{ after(grammarAccess.getPlusOrMinusAccess().getGroup_1_0_0()); }
	)
	|
	(
		{ before(grammarAccess.getPlusOrMinusAccess().getGroup_1_0_1()); }
		(rule__PlusOrMinus__Group_1_0_1__0)
		{ after(grammarAccess.getPlusOrMinusAccess().getGroup_1_0_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__MulOrDiv__Alternatives_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMulOrDivAccess().getGroup_1_0_0()); }
		(rule__MulOrDiv__Group_1_0_0__0)
		{ after(grammarAccess.getMulOrDivAccess().getGroup_1_0_0()); }
	)
	|
	(
		{ before(grammarAccess.getMulOrDivAccess().getGroup_1_0_1()); }
		(rule__MulOrDiv__Group_1_0_1__0)
		{ after(grammarAccess.getMulOrDivAccess().getGroup_1_0_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Primary__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPrimaryAccess().getGroup_0()); }
		(rule__Primary__Group_0__0)
		{ after(grammarAccess.getPrimaryAccess().getGroup_0()); }
	)
	|
	(
		{ before(grammarAccess.getPrimaryAccess().getAtomicParserRuleCall_1()); }
		ruleAtomic
		{ after(grammarAccess.getPrimaryAccess().getAtomicParserRuleCall_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Atomic__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getAtomicAccess().getGroup_0()); }
		(rule__Atomic__Group_0__0)
		{ after(grammarAccess.getAtomicAccess().getGroup_0()); }
	)
	|
	(
		{ before(grammarAccess.getAtomicAccess().getGroup_1()); }
		(rule__Atomic__Group_1__0)
		{ after(grammarAccess.getAtomicAccess().getGroup_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Alternatives_3_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEBigDecimalAccess().getEKeyword_3_0_0()); }
		'E'
		{ after(grammarAccess.getEBigDecimalAccess().getEKeyword_3_0_0()); }
	)
	|
	(
		{ before(grammarAccess.getEBigDecimalAccess().getEKeyword_3_0_1()); }
		'e'
		{ after(grammarAccess.getEBigDecimalAccess().getEKeyword_3_0_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__IID__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getIIDAccess().getINTTerminalRuleCall_0()); }
		RULE_INT
		{ after(grammarAccess.getIIDAccess().getINTTerminalRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getIIDAccess().getIDTerminalRuleCall_1()); }
		RULE_ID
		{ after(grammarAccess.getIIDAccess().getIDTerminalRuleCall_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Settings__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Settings__Group__0__Impl
	rule__Settings__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Settings__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSettingsAccess().getSettingsAction_0()); }
	()
	{ after(grammarAccess.getSettingsAccess().getSettingsAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Settings__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Settings__Group__1__Impl
	rule__Settings__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Settings__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSettingsAccess().getImportsAssignment_1()); }
	(rule__Settings__ImportsAssignment_1)*
	{ after(grammarAccess.getSettingsAccess().getImportsAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Settings__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Settings__Group__2__Impl
	rule__Settings__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__Settings__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSettingsAccess().getDeclarationsAssignment_2()); }
	(rule__Settings__DeclarationsAssignment_2)*
	{ after(grammarAccess.getSettingsAccess().getDeclarationsAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Settings__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Settings__Group__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Settings__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSettingsAccess().getPhysicalSettingsAssignment_3()); }
	(rule__Settings__PhysicalSettingsAssignment_3)*
	{ after(grammarAccess.getSettingsAccess().getPhysicalSettingsAssignment_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Import__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Import__Group__0__Impl
	rule__Import__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Import__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getImportAccess().getImportKeyword_0()); }
	'import'
	{ after(grammarAccess.getImportAccess().getImportKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Import__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Import__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Import__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getImportAccess().getImportURIAssignment_1()); }
	(rule__Import__ImportURIAssignment_1)
	{ after(grammarAccess.getImportAccess().getImportURIAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__PhysicalSettings__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalSettings__Group__0__Impl
	rule__PhysicalSettings__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalSettingsAccess().getPhysicalSettingsAction_0()); }
	()
	{ after(grammarAccess.getPhysicalSettingsAccess().getPhysicalSettingsAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalSettings__Group__1__Impl
	rule__PhysicalSettings__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalSettingsAccess().getResourceAssignment_1()); }
	(rule__PhysicalSettings__ResourceAssignment_1)
	{ after(grammarAccess.getPhysicalSettingsAccess().getResourceAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalSettings__Group__2__Impl
	rule__PhysicalSettings__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalSettingsAccess().getFullStopKeyword_2()); }
	'.'
	{ after(grammarAccess.getPhysicalSettingsAccess().getFullStopKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalSettings__Group__3__Impl
	rule__PhysicalSettings__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalSettingsAccess().getPeripheralAssignment_3()); }
	(rule__PhysicalSettings__PeripheralAssignment_3)
	{ after(grammarAccess.getPhysicalSettingsAccess().getPeripheralAssignment_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalSettings__Group__4__Impl
	rule__PhysicalSettings__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalSettingsAccess().getLeftCurlyBracketKeyword_4()); }
	'{'
	{ after(grammarAccess.getPhysicalSettingsAccess().getLeftCurlyBracketKeyword_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalSettings__Group__5__Impl
	rule__PhysicalSettings__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalSettingsAccess().getGroup_5()); }
	(rule__PhysicalSettings__Group_5__0)?
	{ after(grammarAccess.getPhysicalSettingsAccess().getGroup_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalSettings__Group__6__Impl
	rule__PhysicalSettings__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalSettingsAccess().getMotionSettingsAssignment_6()); }
	(rule__PhysicalSettings__MotionSettingsAssignment_6)*
	{ after(grammarAccess.getPhysicalSettingsAccess().getMotionSettingsAssignment_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalSettings__Group__7__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalSettingsAccess().getRightCurlyBracketKeyword_7()); }
	'}'
	{ after(grammarAccess.getPhysicalSettingsAccess().getRightCurlyBracketKeyword_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__PhysicalSettings__Group_5__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalSettings__Group_5__0__Impl
	rule__PhysicalSettings__Group_5__1
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group_5__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalSettingsAccess().getTimingsKeyword_5_0()); }
	'Timings'
	{ after(grammarAccess.getPhysicalSettingsAccess().getTimingsKeyword_5_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group_5__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalSettings__Group_5__1__Impl
	rule__PhysicalSettings__Group_5__2
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group_5__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalSettingsAccess().getLeftCurlyBracketKeyword_5_1()); }
	'{'
	{ after(grammarAccess.getPhysicalSettingsAccess().getLeftCurlyBracketKeyword_5_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group_5__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalSettings__Group_5__2__Impl
	rule__PhysicalSettings__Group_5__3
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group_5__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalSettingsAccess().getTimingSettingsAssignment_5_2()); }
	(rule__PhysicalSettings__TimingSettingsAssignment_5_2)*
	{ after(grammarAccess.getPhysicalSettingsAccess().getTimingSettingsAssignment_5_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group_5__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalSettings__Group_5__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__Group_5__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalSettingsAccess().getRightCurlyBracketKeyword_5_3()); }
	'}'
	{ after(grammarAccess.getPhysicalSettingsAccess().getRightCurlyBracketKeyword_5_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__MotionSettingsMapEntry__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettingsMapEntry__Group__0__Impl
	rule__MotionSettingsMapEntry__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettingsMapEntry__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsMapEntryAccess().getMotionSettingsMapEntryAction_0()); }
	()
	{ after(grammarAccess.getMotionSettingsMapEntryAccess().getMotionSettingsMapEntryAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettingsMapEntry__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettingsMapEntry__Group__1__Impl
	rule__MotionSettingsMapEntry__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettingsMapEntry__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsMapEntryAccess().getAxisKeyword_1()); }
	'Axis'
	{ after(grammarAccess.getMotionSettingsMapEntryAccess().getAxisKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettingsMapEntry__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettingsMapEntry__Group__2__Impl
	rule__MotionSettingsMapEntry__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettingsMapEntry__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsMapEntryAccess().getKeyAssignment_2()); }
	(rule__MotionSettingsMapEntry__KeyAssignment_2)
	{ after(grammarAccess.getMotionSettingsMapEntryAccess().getKeyAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettingsMapEntry__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettingsMapEntry__Group__3__Impl
	rule__MotionSettingsMapEntry__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettingsMapEntry__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsMapEntryAccess().getLeftCurlyBracketKeyword_3()); }
	'{'
	{ after(grammarAccess.getMotionSettingsMapEntryAccess().getLeftCurlyBracketKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettingsMapEntry__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettingsMapEntry__Group__4__Impl
	rule__MotionSettingsMapEntry__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettingsMapEntry__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsMapEntryAccess().getValueAssignment_4()); }
	(rule__MotionSettingsMapEntry__ValueAssignment_4)
	{ after(grammarAccess.getMotionSettingsMapEntryAccess().getValueAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettingsMapEntry__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettingsMapEntry__Group__5__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettingsMapEntry__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsMapEntryAccess().getRightCurlyBracketKeyword_5()); }
	'}'
	{ after(grammarAccess.getMotionSettingsMapEntryAccess().getRightCurlyBracketKeyword_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__MotionSettings__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettings__Group__0__Impl
	rule__MotionSettings__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsAccess().getMotionSettingsAction_0()); }
	()
	{ after(grammarAccess.getMotionSettingsAccess().getMotionSettingsAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettings__Group__1__Impl
	rule__MotionSettings__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsAccess().getProfilesKeyword_1()); }
	'Profiles'
	{ after(grammarAccess.getMotionSettingsAccess().getProfilesKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettings__Group__2__Impl
	rule__MotionSettings__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsAccess().getLeftCurlyBracketKeyword_2()); }
	'{'
	{ after(grammarAccess.getMotionSettingsAccess().getLeftCurlyBracketKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettings__Group__3__Impl
	rule__MotionSettings__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsAccess().getProfileSettingsAssignment_3()); }
	(rule__MotionSettings__ProfileSettingsAssignment_3)*
	{ after(grammarAccess.getMotionSettingsAccess().getProfileSettingsAssignment_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettings__Group__4__Impl
	rule__MotionSettings__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsAccess().getRightCurlyBracketKeyword_4()); }
	'}'
	{ after(grammarAccess.getMotionSettingsAccess().getRightCurlyBracketKeyword_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettings__Group__5__Impl
	rule__MotionSettings__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsAccess().getGroup_5()); }
	(rule__MotionSettings__Group_5__0)?
	{ after(grammarAccess.getMotionSettingsAccess().getGroup_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettings__Group__6__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsAccess().getGroup_6()); }
	(rule__MotionSettings__Group_6__0)?
	{ after(grammarAccess.getMotionSettingsAccess().getGroup_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__MotionSettings__Group_5__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettings__Group_5__0__Impl
	rule__MotionSettings__Group_5__1
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group_5__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsAccess().getPositionsKeyword_5_0()); }
	'Positions'
	{ after(grammarAccess.getMotionSettingsAccess().getPositionsKeyword_5_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group_5__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettings__Group_5__1__Impl
	rule__MotionSettings__Group_5__2
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group_5__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsAccess().getLeftCurlyBracketKeyword_5_1()); }
	'{'
	{ after(grammarAccess.getMotionSettingsAccess().getLeftCurlyBracketKeyword_5_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group_5__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettings__Group_5__2__Impl
	rule__MotionSettings__Group_5__3
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group_5__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsAccess().getLocationSettingsAssignment_5_2()); }
	(rule__MotionSettings__LocationSettingsAssignment_5_2)*
	{ after(grammarAccess.getMotionSettingsAccess().getLocationSettingsAssignment_5_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group_5__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettings__Group_5__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group_5__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsAccess().getRightCurlyBracketKeyword_5_3()); }
	'}'
	{ after(grammarAccess.getMotionSettingsAccess().getRightCurlyBracketKeyword_5_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__MotionSettings__Group_6__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettings__Group_6__0__Impl
	rule__MotionSettings__Group_6__1
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group_6__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsAccess().getDistancesKeyword_6_0()); }
	'Distances'
	{ after(grammarAccess.getMotionSettingsAccess().getDistancesKeyword_6_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group_6__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettings__Group_6__1__Impl
	rule__MotionSettings__Group_6__2
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group_6__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsAccess().getLeftCurlyBracketKeyword_6_1()); }
	'{'
	{ after(grammarAccess.getMotionSettingsAccess().getLeftCurlyBracketKeyword_6_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group_6__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettings__Group_6__2__Impl
	rule__MotionSettings__Group_6__3
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group_6__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsAccess().getDistanceSettingsAssignment_6_2()); }
	(rule__MotionSettings__DistanceSettingsAssignment_6_2)*
	{ after(grammarAccess.getMotionSettingsAccess().getDistanceSettingsAssignment_6_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group_6__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionSettings__Group_6__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__Group_6__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionSettingsAccess().getRightCurlyBracketKeyword_6_3()); }
	'}'
	{ after(grammarAccess.getMotionSettingsAccess().getRightCurlyBracketKeyword_6_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ProfileSettingsMapEntry__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ProfileSettingsMapEntry__Group__0__Impl
	rule__ProfileSettingsMapEntry__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ProfileSettingsMapEntry__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getProfileSettingsMapEntryAccess().getKeyAssignment_0()); }
	(rule__ProfileSettingsMapEntry__KeyAssignment_0)
	{ after(grammarAccess.getProfileSettingsMapEntryAccess().getKeyAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ProfileSettingsMapEntry__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ProfileSettingsMapEntry__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ProfileSettingsMapEntry__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getProfileSettingsMapEntryAccess().getValueAssignment_1()); }
	(rule__ProfileSettingsMapEntry__ValueAssignment_1)
	{ after(grammarAccess.getProfileSettingsMapEntryAccess().getValueAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__LocationSettingsMapEntry__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__LocationSettingsMapEntry__Group__0__Impl
	rule__LocationSettingsMapEntry__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationSettingsMapEntry__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getLocationSettingsMapEntryAccess().getKeyAssignment_0()); }
	(rule__LocationSettingsMapEntry__KeyAssignment_0)
	{ after(grammarAccess.getLocationSettingsMapEntryAccess().getKeyAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationSettingsMapEntry__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__LocationSettingsMapEntry__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationSettingsMapEntry__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getLocationSettingsMapEntryAccess().getValueAssignment_1()); }
	(rule__LocationSettingsMapEntry__ValueAssignment_1)
	{ after(grammarAccess.getLocationSettingsMapEntryAccess().getValueAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__DistanceSettingsMapEntry__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DistanceSettingsMapEntry__Group__0__Impl
	rule__DistanceSettingsMapEntry__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__DistanceSettingsMapEntry__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDistanceSettingsMapEntryAccess().getKeyAssignment_0()); }
	(rule__DistanceSettingsMapEntry__KeyAssignment_0)
	{ after(grammarAccess.getDistanceSettingsMapEntryAccess().getKeyAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DistanceSettingsMapEntry__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DistanceSettingsMapEntry__Group__1__Impl
	rule__DistanceSettingsMapEntry__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__DistanceSettingsMapEntry__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDistanceSettingsMapEntryAccess().getEqualsSignKeyword_1()); }
	'='
	{ after(grammarAccess.getDistanceSettingsMapEntryAccess().getEqualsSignKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DistanceSettingsMapEntry__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DistanceSettingsMapEntry__Group__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__DistanceSettingsMapEntry__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDistanceSettingsMapEntryAccess().getValueAssignment_2()); }
	(rule__DistanceSettingsMapEntry__ValueAssignment_2)
	{ after(grammarAccess.getDistanceSettingsMapEntryAccess().getValueAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__TimingSettingsMapEntry__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TimingSettingsMapEntry__Group__0__Impl
	rule__TimingSettingsMapEntry__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__TimingSettingsMapEntry__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTimingSettingsMapEntryAccess().getKeyAssignment_0()); }
	(rule__TimingSettingsMapEntry__KeyAssignment_0)
	{ after(grammarAccess.getTimingSettingsMapEntryAccess().getKeyAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TimingSettingsMapEntry__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TimingSettingsMapEntry__Group__1__Impl
	rule__TimingSettingsMapEntry__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__TimingSettingsMapEntry__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTimingSettingsMapEntryAccess().getEqualsSignKeyword_1()); }
	'='
	{ after(grammarAccess.getTimingSettingsMapEntryAccess().getEqualsSignKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TimingSettingsMapEntry__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TimingSettingsMapEntry__Group__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__TimingSettingsMapEntry__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTimingSettingsMapEntryAccess().getValueAssignment_2()); }
	(rule__TimingSettingsMapEntry__ValueAssignment_2)
	{ after(grammarAccess.getTimingSettingsMapEntryAccess().getValueAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__MotionProfileSettings__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionProfileSettings__Group__0__Impl
	rule__MotionProfileSettings__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionProfileSettingsAccess().getMotionProfileSettingsAction_0()); }
	()
	{ after(grammarAccess.getMotionProfileSettingsAccess().getMotionProfileSettingsAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionProfileSettings__Group__1__Impl
	rule__MotionProfileSettings__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionProfileSettingsAccess().getMotionProfileAssignment_1()); }
	(rule__MotionProfileSettings__MotionProfileAssignment_1)?
	{ after(grammarAccess.getMotionProfileSettingsAccess().getMotionProfileAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionProfileSettings__Group__2__Impl
	rule__MotionProfileSettings__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionProfileSettingsAccess().getLeftParenthesisKeyword_2()); }
	'('
	{ after(grammarAccess.getMotionProfileSettingsAccess().getLeftParenthesisKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionProfileSettings__Group__3__Impl
	rule__MotionProfileSettings__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionProfileSettingsAccess().getGroup_3()); }
	(rule__MotionProfileSettings__Group_3__0)?
	{ after(grammarAccess.getMotionProfileSettingsAccess().getGroup_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionProfileSettings__Group__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionProfileSettingsAccess().getRightParenthesisKeyword_4()); }
	')'
	{ after(grammarAccess.getMotionProfileSettingsAccess().getRightParenthesisKeyword_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__MotionProfileSettings__Group_3__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionProfileSettings__Group_3__0__Impl
	rule__MotionProfileSettings__Group_3__1
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__Group_3__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionProfileSettingsAccess().getMotionArgumentsAssignment_3_0()); }
	(rule__MotionProfileSettings__MotionArgumentsAssignment_3_0)
	{ after(grammarAccess.getMotionProfileSettingsAccess().getMotionArgumentsAssignment_3_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__Group_3__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionProfileSettings__Group_3__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__Group_3__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionProfileSettingsAccess().getGroup_3_1()); }
	(rule__MotionProfileSettings__Group_3_1__0)*
	{ after(grammarAccess.getMotionProfileSettingsAccess().getGroup_3_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__MotionProfileSettings__Group_3_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionProfileSettings__Group_3_1__0__Impl
	rule__MotionProfileSettings__Group_3_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__Group_3_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionProfileSettingsAccess().getCommaKeyword_3_1_0()); }
	','
	{ after(grammarAccess.getMotionProfileSettingsAccess().getCommaKeyword_3_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__Group_3_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionProfileSettings__Group_3_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__Group_3_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionProfileSettingsAccess().getMotionArgumentsAssignment_3_1_1()); }
	(rule__MotionProfileSettings__MotionArgumentsAssignment_3_1_1)
	{ after(grammarAccess.getMotionProfileSettingsAccess().getMotionArgumentsAssignment_3_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__MotionArgumentsMapEntry__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionArgumentsMapEntry__Group__0__Impl
	rule__MotionArgumentsMapEntry__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionArgumentsMapEntry__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionArgumentsMapEntryAccess().getKeyAssignment_0()); }
	(rule__MotionArgumentsMapEntry__KeyAssignment_0)
	{ after(grammarAccess.getMotionArgumentsMapEntryAccess().getKeyAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionArgumentsMapEntry__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionArgumentsMapEntry__Group__1__Impl
	rule__MotionArgumentsMapEntry__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionArgumentsMapEntry__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionArgumentsMapEntryAccess().getEqualsSignKeyword_1()); }
	'='
	{ after(grammarAccess.getMotionArgumentsMapEntryAccess().getEqualsSignKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionArgumentsMapEntry__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MotionArgumentsMapEntry__Group__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionArgumentsMapEntry__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMotionArgumentsMapEntryAccess().getValueAssignment_2()); }
	(rule__MotionArgumentsMapEntry__ValueAssignment_2)
	{ after(grammarAccess.getMotionArgumentsMapEntryAccess().getValueAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__PhysicalLocation__Group_0__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_0__0__Impl
	rule__PhysicalLocation__Group_0__1
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_0__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getEqualsSignKeyword_0_0()); }
	'='
	{ after(grammarAccess.getPhysicalLocationAccess().getEqualsSignKeyword_0_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_0__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_0__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_0__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getDefaultExpAssignment_0_1()); }
	(rule__PhysicalLocation__DefaultExpAssignment_0_1)
	{ after(grammarAccess.getPhysicalLocationAccess().getDefaultExpAssignment_0_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__PhysicalLocation__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_1__0__Impl
	rule__PhysicalLocation__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getLeftParenthesisKeyword_1_0()); }
	'('
	{ after(grammarAccess.getPhysicalLocationAccess().getLeftParenthesisKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_1__1__Impl
	rule__PhysicalLocation__Group_1__2
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getGroup_1_1()); }
	(rule__PhysicalLocation__Group_1_1__0)?
	{ after(grammarAccess.getPhysicalLocationAccess().getGroup_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_1__2__Impl
	rule__PhysicalLocation__Group_1__3
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getGroup_1_2()); }
	(rule__PhysicalLocation__Group_1_2__0)?
	{ after(grammarAccess.getPhysicalLocationAccess().getGroup_1_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_1__3__Impl
	rule__PhysicalLocation__Group_1__4
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getDefaultKeyword_1_3()); }
	'default'
	{ after(grammarAccess.getPhysicalLocationAccess().getDefaultKeyword_1_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_1__4__Impl
	rule__PhysicalLocation__Group_1__5
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getEqualsSignKeyword_1_4()); }
	'='
	{ after(grammarAccess.getPhysicalLocationAccess().getEqualsSignKeyword_1_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_1__5__Impl
	rule__PhysicalLocation__Group_1__6
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getDefaultExpAssignment_1_5()); }
	(rule__PhysicalLocation__DefaultExpAssignment_1_5)
	{ after(grammarAccess.getPhysicalLocationAccess().getDefaultExpAssignment_1_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_1__6__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getRightParenthesisKeyword_1_6()); }
	')'
	{ after(grammarAccess.getPhysicalLocationAccess().getRightParenthesisKeyword_1_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__PhysicalLocation__Group_1_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_1_1__0__Impl
	rule__PhysicalLocation__Group_1_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getMinKeyword_1_1_0()); }
	'min'
	{ after(grammarAccess.getPhysicalLocationAccess().getMinKeyword_1_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_1_1__1__Impl
	rule__PhysicalLocation__Group_1_1__2
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getEqualsSignKeyword_1_1_1()); }
	'='
	{ after(grammarAccess.getPhysicalLocationAccess().getEqualsSignKeyword_1_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1_1__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_1_1__2__Impl
	rule__PhysicalLocation__Group_1_1__3
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1_1__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getMinExpAssignment_1_1_2()); }
	(rule__PhysicalLocation__MinExpAssignment_1_1_2)
	{ after(grammarAccess.getPhysicalLocationAccess().getMinExpAssignment_1_1_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1_1__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_1_1__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1_1__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getCommaKeyword_1_1_3()); }
	','
	{ after(grammarAccess.getPhysicalLocationAccess().getCommaKeyword_1_1_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__PhysicalLocation__Group_1_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_1_2__0__Impl
	rule__PhysicalLocation__Group_1_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getMaxKeyword_1_2_0()); }
	'max'
	{ after(grammarAccess.getPhysicalLocationAccess().getMaxKeyword_1_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_1_2__1__Impl
	rule__PhysicalLocation__Group_1_2__2
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getEqualsSignKeyword_1_2_1()); }
	'='
	{ after(grammarAccess.getPhysicalLocationAccess().getEqualsSignKeyword_1_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1_2__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_1_2__2__Impl
	rule__PhysicalLocation__Group_1_2__3
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1_2__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getMaxExpAssignment_1_2_2()); }
	(rule__PhysicalLocation__MaxExpAssignment_1_2_2)
	{ after(grammarAccess.getPhysicalLocationAccess().getMaxExpAssignment_1_2_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1_2__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PhysicalLocation__Group_1_2__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__Group_1_2__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPhysicalLocationAccess().getCommaKeyword_1_2_3()); }
	','
	{ after(grammarAccess.getPhysicalLocationAccess().getCommaKeyword_1_2_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Array__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Array__Group__0__Impl
	rule__Array__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Array__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getArrayAccess().getArrayKeyword_0()); }
	'Array'
	{ after(grammarAccess.getArrayAccess().getArrayKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Array__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Array__Group__1__Impl
	rule__Array__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Array__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getArrayAccess().getLeftParenthesisKeyword_1()); }
	'('
	{ after(grammarAccess.getArrayAccess().getLeftParenthesisKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Array__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Array__Group__2__Impl
	rule__Array__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__Array__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getArrayAccess().getValuesExpAssignment_2()); }
	(rule__Array__ValuesExpAssignment_2)
	{ after(grammarAccess.getArrayAccess().getValuesExpAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Array__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Array__Group__3__Impl
	rule__Array__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__Array__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getArrayAccess().getGroup_3()); }
	(rule__Array__Group_3__0)*
	{ after(grammarAccess.getArrayAccess().getGroup_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Array__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Array__Group__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Array__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getArrayAccess().getRightParenthesisKeyword_4()); }
	')'
	{ after(grammarAccess.getArrayAccess().getRightParenthesisKeyword_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Array__Group_3__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Array__Group_3__0__Impl
	rule__Array__Group_3__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Array__Group_3__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getArrayAccess().getCommaKeyword_3_0()); }
	','
	{ after(grammarAccess.getArrayAccess().getCommaKeyword_3_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Array__Group_3__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Array__Group_3__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Array__Group_3__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getArrayAccess().getValuesExpAssignment_3_1()); }
	(rule__Array__ValuesExpAssignment_3_1)
	{ after(grammarAccess.getArrayAccess().getValuesExpAssignment_3_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__TriangularDistribution__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group__0__Impl
	rule__TriangularDistribution__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getTriangularKeyword_0()); }
	'Triangular'
	{ after(grammarAccess.getTriangularDistributionAccess().getTriangularKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group__1__Impl
	rule__TriangularDistribution__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getLeftParenthesisKeyword_1()); }
	'('
	{ after(grammarAccess.getTriangularDistributionAccess().getLeftParenthesisKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group__2__Impl
	rule__TriangularDistribution__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getMinKeyword_2()); }
	'min'
	{ after(grammarAccess.getTriangularDistributionAccess().getMinKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group__3__Impl
	rule__TriangularDistribution__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getEqualsSignKeyword_3()); }
	'='
	{ after(grammarAccess.getTriangularDistributionAccess().getEqualsSignKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group__4__Impl
	rule__TriangularDistribution__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getMinExpAssignment_4()); }
	(rule__TriangularDistribution__MinExpAssignment_4)
	{ after(grammarAccess.getTriangularDistributionAccess().getMinExpAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group__5__Impl
	rule__TriangularDistribution__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getCommaKeyword_5()); }
	','
	{ after(grammarAccess.getTriangularDistributionAccess().getCommaKeyword_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group__6__Impl
	rule__TriangularDistribution__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getMaxKeyword_6()); }
	'max'
	{ after(grammarAccess.getTriangularDistributionAccess().getMaxKeyword_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group__7__Impl
	rule__TriangularDistribution__Group__8
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getEqualsSignKeyword_7()); }
	'='
	{ after(grammarAccess.getTriangularDistributionAccess().getEqualsSignKeyword_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__8
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group__8__Impl
	rule__TriangularDistribution__Group__9
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__8__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getMaxExpAssignment_8()); }
	(rule__TriangularDistribution__MaxExpAssignment_8)
	{ after(grammarAccess.getTriangularDistributionAccess().getMaxExpAssignment_8()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__9
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group__9__Impl
	rule__TriangularDistribution__Group__10
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__9__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getCommaKeyword_9()); }
	','
	{ after(grammarAccess.getTriangularDistributionAccess().getCommaKeyword_9()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__10
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group__10__Impl
	rule__TriangularDistribution__Group__11
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__10__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getModeKeyword_10()); }
	'mode'
	{ after(grammarAccess.getTriangularDistributionAccess().getModeKeyword_10()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__11
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group__11__Impl
	rule__TriangularDistribution__Group__12
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__11__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getEqualsSignKeyword_11()); }
	'='
	{ after(grammarAccess.getTriangularDistributionAccess().getEqualsSignKeyword_11()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__12
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group__12__Impl
	rule__TriangularDistribution__Group__13
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__12__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getModeExpAssignment_12()); }
	(rule__TriangularDistribution__ModeExpAssignment_12)
	{ after(grammarAccess.getTriangularDistributionAccess().getModeExpAssignment_12()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__13
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group__13__Impl
	rule__TriangularDistribution__Group__14
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__13__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getGroup_13()); }
	(rule__TriangularDistribution__Group_13__0)?
	{ after(grammarAccess.getTriangularDistributionAccess().getGroup_13()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__14
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group__14__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group__14__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getRightParenthesisKeyword_14()); }
	')'
	{ after(grammarAccess.getTriangularDistributionAccess().getRightParenthesisKeyword_14()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__TriangularDistribution__Group_13__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group_13__0__Impl
	rule__TriangularDistribution__Group_13__1
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group_13__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getCommaKeyword_13_0()); }
	','
	{ after(grammarAccess.getTriangularDistributionAccess().getCommaKeyword_13_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group_13__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group_13__1__Impl
	rule__TriangularDistribution__Group_13__2
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group_13__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getDefaultKeyword_13_1()); }
	'default'
	{ after(grammarAccess.getTriangularDistributionAccess().getDefaultKeyword_13_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group_13__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group_13__2__Impl
	rule__TriangularDistribution__Group_13__3
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group_13__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getEqualsSignKeyword_13_2()); }
	'='
	{ after(grammarAccess.getTriangularDistributionAccess().getEqualsSignKeyword_13_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group_13__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TriangularDistribution__Group_13__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__Group_13__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTriangularDistributionAccess().getDefaultExpAssignment_13_3()); }
	(rule__TriangularDistribution__DefaultExpAssignment_13_3)
	{ after(grammarAccess.getTriangularDistributionAccess().getDefaultExpAssignment_13_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__PertDistribution__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__0__Impl
	rule__PertDistribution__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getPertKeyword_0()); }
	'Pert'
	{ after(grammarAccess.getPertDistributionAccess().getPertKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__1__Impl
	rule__PertDistribution__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getLeftParenthesisKeyword_1()); }
	'('
	{ after(grammarAccess.getPertDistributionAccess().getLeftParenthesisKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__2__Impl
	rule__PertDistribution__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getMinKeyword_2()); }
	'min'
	{ after(grammarAccess.getPertDistributionAccess().getMinKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__3__Impl
	rule__PertDistribution__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getEqualsSignKeyword_3()); }
	'='
	{ after(grammarAccess.getPertDistributionAccess().getEqualsSignKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__4__Impl
	rule__PertDistribution__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getMinExpAssignment_4()); }
	(rule__PertDistribution__MinExpAssignment_4)
	{ after(grammarAccess.getPertDistributionAccess().getMinExpAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__5__Impl
	rule__PertDistribution__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getCommaKeyword_5()); }
	','
	{ after(grammarAccess.getPertDistributionAccess().getCommaKeyword_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__6__Impl
	rule__PertDistribution__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getMaxKeyword_6()); }
	'max'
	{ after(grammarAccess.getPertDistributionAccess().getMaxKeyword_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__7__Impl
	rule__PertDistribution__Group__8
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getEqualsSignKeyword_7()); }
	'='
	{ after(grammarAccess.getPertDistributionAccess().getEqualsSignKeyword_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__8
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__8__Impl
	rule__PertDistribution__Group__9
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__8__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getMaxExpAssignment_8()); }
	(rule__PertDistribution__MaxExpAssignment_8)
	{ after(grammarAccess.getPertDistributionAccess().getMaxExpAssignment_8()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__9
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__9__Impl
	rule__PertDistribution__Group__10
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__9__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getCommaKeyword_9()); }
	','
	{ after(grammarAccess.getPertDistributionAccess().getCommaKeyword_9()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__10
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__10__Impl
	rule__PertDistribution__Group__11
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__10__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getModeKeyword_10()); }
	'mode'
	{ after(grammarAccess.getPertDistributionAccess().getModeKeyword_10()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__11
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__11__Impl
	rule__PertDistribution__Group__12
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__11__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getEqualsSignKeyword_11()); }
	'='
	{ after(grammarAccess.getPertDistributionAccess().getEqualsSignKeyword_11()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__12
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__12__Impl
	rule__PertDistribution__Group__13
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__12__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getModeExpAssignment_12()); }
	(rule__PertDistribution__ModeExpAssignment_12)
	{ after(grammarAccess.getPertDistributionAccess().getModeExpAssignment_12()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__13
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__13__Impl
	rule__PertDistribution__Group__14
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__13__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getCommaKeyword_13()); }
	','
	{ after(grammarAccess.getPertDistributionAccess().getCommaKeyword_13()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__14
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__14__Impl
	rule__PertDistribution__Group__15
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__14__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getGammaKeyword_14()); }
	'gamma'
	{ after(grammarAccess.getPertDistributionAccess().getGammaKeyword_14()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__15
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__15__Impl
	rule__PertDistribution__Group__16
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__15__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getEqualsSignKeyword_15()); }
	'='
	{ after(grammarAccess.getPertDistributionAccess().getEqualsSignKeyword_15()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__16
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__16__Impl
	rule__PertDistribution__Group__17
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__16__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getGammaExpAssignment_16()); }
	(rule__PertDistribution__GammaExpAssignment_16)
	{ after(grammarAccess.getPertDistributionAccess().getGammaExpAssignment_16()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__17
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__17__Impl
	rule__PertDistribution__Group__18
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__17__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getGroup_17()); }
	(rule__PertDistribution__Group_17__0)?
	{ after(grammarAccess.getPertDistributionAccess().getGroup_17()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__18
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group__18__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group__18__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getRightParenthesisKeyword_18()); }
	')'
	{ after(grammarAccess.getPertDistributionAccess().getRightParenthesisKeyword_18()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__PertDistribution__Group_17__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group_17__0__Impl
	rule__PertDistribution__Group_17__1
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group_17__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getCommaKeyword_17_0()); }
	','
	{ after(grammarAccess.getPertDistributionAccess().getCommaKeyword_17_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group_17__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group_17__1__Impl
	rule__PertDistribution__Group_17__2
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group_17__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getDefaultKeyword_17_1()); }
	'default'
	{ after(grammarAccess.getPertDistributionAccess().getDefaultKeyword_17_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group_17__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group_17__2__Impl
	rule__PertDistribution__Group_17__3
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group_17__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getEqualsSignKeyword_17_2()); }
	'='
	{ after(grammarAccess.getPertDistributionAccess().getEqualsSignKeyword_17_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group_17__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PertDistribution__Group_17__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__Group_17__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPertDistributionAccess().getDefaultExpAssignment_17_3()); }
	(rule__PertDistribution__DefaultExpAssignment_17_3)
	{ after(grammarAccess.getPertDistributionAccess().getDefaultExpAssignment_17_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__NormalDistribution__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NormalDistribution__Group__0__Impl
	rule__NormalDistribution__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNormalDistributionAccess().getNormalKeyword_0()); }
	'Normal'
	{ after(grammarAccess.getNormalDistributionAccess().getNormalKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NormalDistribution__Group__1__Impl
	rule__NormalDistribution__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNormalDistributionAccess().getLeftParenthesisKeyword_1()); }
	'('
	{ after(grammarAccess.getNormalDistributionAccess().getLeftParenthesisKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NormalDistribution__Group__2__Impl
	rule__NormalDistribution__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNormalDistributionAccess().getMeanKeyword_2()); }
	'mean'
	{ after(grammarAccess.getNormalDistributionAccess().getMeanKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NormalDistribution__Group__3__Impl
	rule__NormalDistribution__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNormalDistributionAccess().getEqualsSignKeyword_3()); }
	'='
	{ after(grammarAccess.getNormalDistributionAccess().getEqualsSignKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NormalDistribution__Group__4__Impl
	rule__NormalDistribution__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNormalDistributionAccess().getMeanExpAssignment_4()); }
	(rule__NormalDistribution__MeanExpAssignment_4)
	{ after(grammarAccess.getNormalDistributionAccess().getMeanExpAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NormalDistribution__Group__5__Impl
	rule__NormalDistribution__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNormalDistributionAccess().getCommaKeyword_5()); }
	','
	{ after(grammarAccess.getNormalDistributionAccess().getCommaKeyword_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NormalDistribution__Group__6__Impl
	rule__NormalDistribution__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNormalDistributionAccess().getSdKeyword_6()); }
	'sd'
	{ after(grammarAccess.getNormalDistributionAccess().getSdKeyword_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NormalDistribution__Group__7__Impl
	rule__NormalDistribution__Group__8
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNormalDistributionAccess().getEqualsSignKeyword_7()); }
	'='
	{ after(grammarAccess.getNormalDistributionAccess().getEqualsSignKeyword_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__8
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NormalDistribution__Group__8__Impl
	rule__NormalDistribution__Group__9
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__8__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNormalDistributionAccess().getSdExpAssignment_8()); }
	(rule__NormalDistribution__SdExpAssignment_8)
	{ after(grammarAccess.getNormalDistributionAccess().getSdExpAssignment_8()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__9
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NormalDistribution__Group__9__Impl
	rule__NormalDistribution__Group__10
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__9__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNormalDistributionAccess().getGroup_9()); }
	(rule__NormalDistribution__Group_9__0)?
	{ after(grammarAccess.getNormalDistributionAccess().getGroup_9()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__10
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NormalDistribution__Group__10__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group__10__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNormalDistributionAccess().getRightParenthesisKeyword_10()); }
	')'
	{ after(grammarAccess.getNormalDistributionAccess().getRightParenthesisKeyword_10()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__NormalDistribution__Group_9__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NormalDistribution__Group_9__0__Impl
	rule__NormalDistribution__Group_9__1
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group_9__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNormalDistributionAccess().getCommaKeyword_9_0()); }
	','
	{ after(grammarAccess.getNormalDistributionAccess().getCommaKeyword_9_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group_9__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NormalDistribution__Group_9__1__Impl
	rule__NormalDistribution__Group_9__2
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group_9__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNormalDistributionAccess().getDefaultKeyword_9_1()); }
	'default'
	{ after(grammarAccess.getNormalDistributionAccess().getDefaultKeyword_9_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group_9__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NormalDistribution__Group_9__2__Impl
	rule__NormalDistribution__Group_9__3
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group_9__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNormalDistributionAccess().getEqualsSignKeyword_9_2()); }
	'='
	{ after(grammarAccess.getNormalDistributionAccess().getEqualsSignKeyword_9_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group_9__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NormalDistribution__Group_9__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__Group_9__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNormalDistributionAccess().getDefaultExpAssignment_9_3()); }
	(rule__NormalDistribution__DefaultExpAssignment_9_3)
	{ after(grammarAccess.getNormalDistributionAccess().getDefaultExpAssignment_9_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EnumeratedDistribution__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumeratedDistribution__Group__0__Impl
	rule__EnumeratedDistribution__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumeratedDistributionAccess().getEnumeratedKeyword_0()); }
	'Enumerated'
	{ after(grammarAccess.getEnumeratedDistributionAccess().getEnumeratedKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumeratedDistribution__Group__1__Impl
	rule__EnumeratedDistribution__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumeratedDistributionAccess().getLeftParenthesisKeyword_1()); }
	'('
	{ after(grammarAccess.getEnumeratedDistributionAccess().getLeftParenthesisKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumeratedDistribution__Group__2__Impl
	rule__EnumeratedDistribution__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumeratedDistributionAccess().getValuesExpAssignment_2()); }
	(rule__EnumeratedDistribution__ValuesExpAssignment_2)
	{ after(grammarAccess.getEnumeratedDistributionAccess().getValuesExpAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumeratedDistribution__Group__3__Impl
	rule__EnumeratedDistribution__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumeratedDistributionAccess().getGroup_3()); }
	(rule__EnumeratedDistribution__Group_3__0)*
	{ after(grammarAccess.getEnumeratedDistributionAccess().getGroup_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumeratedDistribution__Group__4__Impl
	rule__EnumeratedDistribution__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumeratedDistributionAccess().getGroup_4()); }
	(rule__EnumeratedDistribution__Group_4__0)?
	{ after(grammarAccess.getEnumeratedDistributionAccess().getGroup_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumeratedDistribution__Group__5__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumeratedDistributionAccess().getRightParenthesisKeyword_5()); }
	')'
	{ after(grammarAccess.getEnumeratedDistributionAccess().getRightParenthesisKeyword_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EnumeratedDistribution__Group_3__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumeratedDistribution__Group_3__0__Impl
	rule__EnumeratedDistribution__Group_3__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group_3__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumeratedDistributionAccess().getCommaKeyword_3_0()); }
	','
	{ after(grammarAccess.getEnumeratedDistributionAccess().getCommaKeyword_3_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group_3__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumeratedDistribution__Group_3__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group_3__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumeratedDistributionAccess().getValuesExpAssignment_3_1()); }
	(rule__EnumeratedDistribution__ValuesExpAssignment_3_1)
	{ after(grammarAccess.getEnumeratedDistributionAccess().getValuesExpAssignment_3_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EnumeratedDistribution__Group_4__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumeratedDistribution__Group_4__0__Impl
	rule__EnumeratedDistribution__Group_4__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group_4__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumeratedDistributionAccess().getCommaKeyword_4_0()); }
	','
	{ after(grammarAccess.getEnumeratedDistributionAccess().getCommaKeyword_4_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group_4__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumeratedDistribution__Group_4__1__Impl
	rule__EnumeratedDistribution__Group_4__2
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group_4__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumeratedDistributionAccess().getDefaultKeyword_4_1()); }
	'default'
	{ after(grammarAccess.getEnumeratedDistributionAccess().getDefaultKeyword_4_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group_4__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumeratedDistribution__Group_4__2__Impl
	rule__EnumeratedDistribution__Group_4__3
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group_4__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumeratedDistributionAccess().getEqualsSignKeyword_4_2()); }
	'='
	{ after(grammarAccess.getEnumeratedDistributionAccess().getEqualsSignKeyword_4_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group_4__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumeratedDistribution__Group_4__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__Group_4__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumeratedDistributionAccess().getDefaultExpAssignment_4_3()); }
	(rule__EnumeratedDistribution__DefaultExpAssignment_4_3)
	{ after(grammarAccess.getEnumeratedDistributionAccess().getDefaultExpAssignment_4_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Declaration__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Declaration__Group__0__Impl
	rule__Declaration__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Declaration__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDeclarationAccess().getDeclarationAction_0()); }
	()
	{ after(grammarAccess.getDeclarationAccess().getDeclarationAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Declaration__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Declaration__Group__1__Impl
	rule__Declaration__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Declaration__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDeclarationAccess().getValKeyword_1()); }
	'val'
	{ after(grammarAccess.getDeclarationAccess().getValKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Declaration__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Declaration__Group__2__Impl
	rule__Declaration__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__Declaration__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDeclarationAccess().getNameAssignment_2()); }
	(rule__Declaration__NameAssignment_2)
	{ after(grammarAccess.getDeclarationAccess().getNameAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Declaration__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Declaration__Group__3__Impl
	rule__Declaration__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__Declaration__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDeclarationAccess().getEqualsSignKeyword_3()); }
	'='
	{ after(grammarAccess.getDeclarationAccess().getEqualsSignKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Declaration__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Declaration__Group__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Declaration__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDeclarationAccess().getExpressionAssignment_4()); }
	(rule__Declaration__ExpressionAssignment_4)
	{ after(grammarAccess.getDeclarationAccess().getExpressionAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__PlusOrMinus__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PlusOrMinus__Group__0__Impl
	rule__PlusOrMinus__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__PlusOrMinus__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPlusOrMinusAccess().getMulOrDivParserRuleCall_0()); }
	ruleMulOrDiv
	{ after(grammarAccess.getPlusOrMinusAccess().getMulOrDivParserRuleCall_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PlusOrMinus__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PlusOrMinus__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__PlusOrMinus__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPlusOrMinusAccess().getGroup_1()); }
	(rule__PlusOrMinus__Group_1__0)*
	{ after(grammarAccess.getPlusOrMinusAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__PlusOrMinus__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PlusOrMinus__Group_1__0__Impl
	rule__PlusOrMinus__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__PlusOrMinus__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPlusOrMinusAccess().getAlternatives_1_0()); }
	(rule__PlusOrMinus__Alternatives_1_0)
	{ after(grammarAccess.getPlusOrMinusAccess().getAlternatives_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PlusOrMinus__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PlusOrMinus__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__PlusOrMinus__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPlusOrMinusAccess().getRightAssignment_1_1()); }
	(rule__PlusOrMinus__RightAssignment_1_1)
	{ after(grammarAccess.getPlusOrMinusAccess().getRightAssignment_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__PlusOrMinus__Group_1_0_0__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PlusOrMinus__Group_1_0_0__0__Impl
	rule__PlusOrMinus__Group_1_0_0__1
;
finally {
	restoreStackSize(stackSize);
}

rule__PlusOrMinus__Group_1_0_0__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPlusOrMinusAccess().getAddLeftAction_1_0_0_0()); }
	()
	{ after(grammarAccess.getPlusOrMinusAccess().getAddLeftAction_1_0_0_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PlusOrMinus__Group_1_0_0__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PlusOrMinus__Group_1_0_0__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__PlusOrMinus__Group_1_0_0__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPlusOrMinusAccess().getPlusSignKeyword_1_0_0_1()); }
	'+'
	{ after(grammarAccess.getPlusOrMinusAccess().getPlusSignKeyword_1_0_0_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__PlusOrMinus__Group_1_0_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PlusOrMinus__Group_1_0_1__0__Impl
	rule__PlusOrMinus__Group_1_0_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__PlusOrMinus__Group_1_0_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPlusOrMinusAccess().getSubtractLeftAction_1_0_1_0()); }
	()
	{ after(grammarAccess.getPlusOrMinusAccess().getSubtractLeftAction_1_0_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__PlusOrMinus__Group_1_0_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__PlusOrMinus__Group_1_0_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__PlusOrMinus__Group_1_0_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPlusOrMinusAccess().getHyphenMinusKeyword_1_0_1_1()); }
	'-'
	{ after(grammarAccess.getPlusOrMinusAccess().getHyphenMinusKeyword_1_0_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__MulOrDiv__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MulOrDiv__Group__0__Impl
	rule__MulOrDiv__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__MulOrDiv__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMulOrDivAccess().getPrimaryParserRuleCall_0()); }
	rulePrimary
	{ after(grammarAccess.getMulOrDivAccess().getPrimaryParserRuleCall_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MulOrDiv__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MulOrDiv__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__MulOrDiv__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMulOrDivAccess().getGroup_1()); }
	(rule__MulOrDiv__Group_1__0)*
	{ after(grammarAccess.getMulOrDivAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__MulOrDiv__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MulOrDiv__Group_1__0__Impl
	rule__MulOrDiv__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__MulOrDiv__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMulOrDivAccess().getAlternatives_1_0()); }
	(rule__MulOrDiv__Alternatives_1_0)
	{ after(grammarAccess.getMulOrDivAccess().getAlternatives_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MulOrDiv__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MulOrDiv__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__MulOrDiv__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMulOrDivAccess().getRightAssignment_1_1()); }
	(rule__MulOrDiv__RightAssignment_1_1)
	{ after(grammarAccess.getMulOrDivAccess().getRightAssignment_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__MulOrDiv__Group_1_0_0__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MulOrDiv__Group_1_0_0__0__Impl
	rule__MulOrDiv__Group_1_0_0__1
;
finally {
	restoreStackSize(stackSize);
}

rule__MulOrDiv__Group_1_0_0__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMulOrDivAccess().getMultiplyLeftAction_1_0_0_0()); }
	()
	{ after(grammarAccess.getMulOrDivAccess().getMultiplyLeftAction_1_0_0_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MulOrDiv__Group_1_0_0__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MulOrDiv__Group_1_0_0__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__MulOrDiv__Group_1_0_0__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMulOrDivAccess().getAsteriskKeyword_1_0_0_1()); }
	'*'
	{ after(grammarAccess.getMulOrDivAccess().getAsteriskKeyword_1_0_0_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__MulOrDiv__Group_1_0_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MulOrDiv__Group_1_0_1__0__Impl
	rule__MulOrDiv__Group_1_0_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__MulOrDiv__Group_1_0_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMulOrDivAccess().getDivideLeftAction_1_0_1_0()); }
	()
	{ after(grammarAccess.getMulOrDivAccess().getDivideLeftAction_1_0_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__MulOrDiv__Group_1_0_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__MulOrDiv__Group_1_0_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__MulOrDiv__Group_1_0_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMulOrDivAccess().getSolidusKeyword_1_0_1_1()); }
	'/'
	{ after(grammarAccess.getMulOrDivAccess().getSolidusKeyword_1_0_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Primary__Group_0__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Primary__Group_0__0__Impl
	rule__Primary__Group_0__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Primary__Group_0__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPrimaryAccess().getLeftParenthesisKeyword_0_0()); }
	'('
	{ after(grammarAccess.getPrimaryAccess().getLeftParenthesisKeyword_0_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Primary__Group_0__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Primary__Group_0__1__Impl
	rule__Primary__Group_0__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Primary__Group_0__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPrimaryAccess().getExpressionParserRuleCall_0_1()); }
	ruleExpression
	{ after(grammarAccess.getPrimaryAccess().getExpressionParserRuleCall_0_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Primary__Group_0__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Primary__Group_0__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Primary__Group_0__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getPrimaryAccess().getRightParenthesisKeyword_0_2()); }
	')'
	{ after(grammarAccess.getPrimaryAccess().getRightParenthesisKeyword_0_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Atomic__Group_0__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Atomic__Group_0__0__Impl
	rule__Atomic__Group_0__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Atomic__Group_0__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getAtomicAccess().getBigDecimalConstantAction_0_0()); }
	()
	{ after(grammarAccess.getAtomicAccess().getBigDecimalConstantAction_0_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Atomic__Group_0__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Atomic__Group_0__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Atomic__Group_0__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getAtomicAccess().getValueAssignment_0_1()); }
	(rule__Atomic__ValueAssignment_0_1)
	{ after(grammarAccess.getAtomicAccess().getValueAssignment_0_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Atomic__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Atomic__Group_1__0__Impl
	rule__Atomic__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Atomic__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getAtomicAccess().getDeclarationRefAction_1_0()); }
	()
	{ after(grammarAccess.getAtomicAccess().getDeclarationRefAction_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Atomic__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Atomic__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Atomic__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getAtomicAccess().getDeclarationAssignment_1_1()); }
	(rule__Atomic__DeclarationAssignment_1_1)
	{ after(grammarAccess.getAtomicAccess().getDeclarationAssignment_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EBigDecimal__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group__0__Impl
	rule__EBigDecimal__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getHyphenMinusKeyword_0()); }
	('-')?
	{ after(grammarAccess.getEBigDecimalAccess().getHyphenMinusKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group__1__Impl
	rule__EBigDecimal__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_1()); }
	RULE_INT
	{ after(grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group__2__Impl
	rule__EBigDecimal__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getGroup_2()); }
	(rule__EBigDecimal__Group_2__0)?
	{ after(grammarAccess.getEBigDecimalAccess().getGroup_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getGroup_3()); }
	(rule__EBigDecimal__Group_3__0)?
	{ after(grammarAccess.getEBigDecimalAccess().getGroup_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EBigDecimal__Group_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group_2__0__Impl
	rule__EBigDecimal__Group_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getFullStopKeyword_2_0()); }
	'.'
	{ after(grammarAccess.getEBigDecimalAccess().getFullStopKeyword_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group_2__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_2_1()); }
	RULE_INT
	{ after(grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EBigDecimal__Group_3__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group_3__0__Impl
	rule__EBigDecimal__Group_3__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group_3__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getAlternatives_3_0()); }
	(rule__EBigDecimal__Alternatives_3_0)
	{ after(grammarAccess.getEBigDecimalAccess().getAlternatives_3_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group_3__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group_3__1__Impl
	rule__EBigDecimal__Group_3__2
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group_3__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getHyphenMinusKeyword_3_1()); }
	('-')?
	{ after(grammarAccess.getEBigDecimalAccess().getHyphenMinusKeyword_3_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group_3__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group_3__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group_3__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_3_2()); }
	RULE_INT
	{ after(grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_3_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ResourceQualifiedName__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceQualifiedName__Group__0__Impl
	rule__ResourceQualifiedName__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_0()); }
	ruleIID
	{ after(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceQualifiedName__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceQualifiedNameAccess().getGroup_1()); }
	(rule__ResourceQualifiedName__Group_1__0)?
	{ after(grammarAccess.getResourceQualifiedNameAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ResourceQualifiedName__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceQualifiedName__Group_1__0__Impl
	rule__ResourceQualifiedName__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceQualifiedNameAccess().getFullStopKeyword_1_0()); }
	'.'
	{ after(grammarAccess.getResourceQualifiedNameAccess().getFullStopKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceQualifiedName__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_1_1()); }
	ruleIID
	{ after(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Settings__ImportsAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSettingsAccess().getImportsImportParserRuleCall_1_0()); }
		ruleImport
		{ after(grammarAccess.getSettingsAccess().getImportsImportParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Settings__DeclarationsAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSettingsAccess().getDeclarationsDeclarationParserRuleCall_2_0()); }
		ruleDeclaration
		{ after(grammarAccess.getSettingsAccess().getDeclarationsDeclarationParserRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Settings__PhysicalSettingsAssignment_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSettingsAccess().getPhysicalSettingsPhysicalSettingsParserRuleCall_3_0()); }
		rulePhysicalSettings
		{ after(grammarAccess.getSettingsAccess().getPhysicalSettingsPhysicalSettingsParserRuleCall_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Import__ImportURIAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getImportAccess().getImportURISTRINGTerminalRuleCall_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getImportAccess().getImportURISTRINGTerminalRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__ResourceAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPhysicalSettingsAccess().getResourceIResourceCrossReference_1_0()); }
		(
			{ before(grammarAccess.getPhysicalSettingsAccess().getResourceIResourceResourceQualifiedNameParserRuleCall_1_0_1()); }
			ruleResourceQualifiedName
			{ after(grammarAccess.getPhysicalSettingsAccess().getResourceIResourceResourceQualifiedNameParserRuleCall_1_0_1()); }
		)
		{ after(grammarAccess.getPhysicalSettingsAccess().getResourceIResourceCrossReference_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__PeripheralAssignment_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPhysicalSettingsAccess().getPeripheralPeripheralCrossReference_3_0()); }
		(
			{ before(grammarAccess.getPhysicalSettingsAccess().getPeripheralPeripheralIIDParserRuleCall_3_0_1()); }
			ruleIID
			{ after(grammarAccess.getPhysicalSettingsAccess().getPeripheralPeripheralIIDParserRuleCall_3_0_1()); }
		)
		{ after(grammarAccess.getPhysicalSettingsAccess().getPeripheralPeripheralCrossReference_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__TimingSettingsAssignment_5_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPhysicalSettingsAccess().getTimingSettingsTimingSettingsMapEntryParserRuleCall_5_2_0()); }
		ruleTimingSettingsMapEntry
		{ after(grammarAccess.getPhysicalSettingsAccess().getTimingSettingsTimingSettingsMapEntryParserRuleCall_5_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalSettings__MotionSettingsAssignment_6
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPhysicalSettingsAccess().getMotionSettingsMotionSettingsMapEntryParserRuleCall_6_0()); }
		ruleMotionSettingsMapEntry
		{ after(grammarAccess.getPhysicalSettingsAccess().getMotionSettingsMotionSettingsMapEntryParserRuleCall_6_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettingsMapEntry__KeyAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMotionSettingsMapEntryAccess().getKeyAxisCrossReference_2_0()); }
		(
			{ before(grammarAccess.getMotionSettingsMapEntryAccess().getKeyAxisIDTerminalRuleCall_2_0_1()); }
			RULE_ID
			{ after(grammarAccess.getMotionSettingsMapEntryAccess().getKeyAxisIDTerminalRuleCall_2_0_1()); }
		)
		{ after(grammarAccess.getMotionSettingsMapEntryAccess().getKeyAxisCrossReference_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettingsMapEntry__ValueAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMotionSettingsMapEntryAccess().getValueMotionSettingsParserRuleCall_4_0()); }
		ruleMotionSettings
		{ after(grammarAccess.getMotionSettingsMapEntryAccess().getValueMotionSettingsParserRuleCall_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__ProfileSettingsAssignment_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMotionSettingsAccess().getProfileSettingsProfileSettingsMapEntryParserRuleCall_3_0()); }
		ruleProfileSettingsMapEntry
		{ after(grammarAccess.getMotionSettingsAccess().getProfileSettingsProfileSettingsMapEntryParserRuleCall_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__LocationSettingsAssignment_5_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMotionSettingsAccess().getLocationSettingsLocationSettingsMapEntryParserRuleCall_5_2_0()); }
		ruleLocationSettingsMapEntry
		{ after(grammarAccess.getMotionSettingsAccess().getLocationSettingsLocationSettingsMapEntryParserRuleCall_5_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionSettings__DistanceSettingsAssignment_6_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMotionSettingsAccess().getDistanceSettingsDistanceSettingsMapEntryParserRuleCall_6_2_0()); }
		ruleDistanceSettingsMapEntry
		{ after(grammarAccess.getMotionSettingsAccess().getDistanceSettingsDistanceSettingsMapEntryParserRuleCall_6_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ProfileSettingsMapEntry__KeyAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getProfileSettingsMapEntryAccess().getKeyProfileCrossReference_0_0()); }
		(
			{ before(grammarAccess.getProfileSettingsMapEntryAccess().getKeyProfileIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getProfileSettingsMapEntryAccess().getKeyProfileIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getProfileSettingsMapEntryAccess().getKeyProfileCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ProfileSettingsMapEntry__ValueAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getProfileSettingsMapEntryAccess().getValueMotionProfileSettingsParserRuleCall_1_0()); }
		ruleMotionProfileSettings
		{ after(grammarAccess.getProfileSettingsMapEntryAccess().getValueMotionProfileSettingsParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationSettingsMapEntry__KeyAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getLocationSettingsMapEntryAccess().getKeyPositionCrossReference_0_0()); }
		(
			{ before(grammarAccess.getLocationSettingsMapEntryAccess().getKeyPositionIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getLocationSettingsMapEntryAccess().getKeyPositionIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getLocationSettingsMapEntryAccess().getKeyPositionCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationSettingsMapEntry__ValueAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getLocationSettingsMapEntryAccess().getValuePhysicalLocationParserRuleCall_1_0()); }
		rulePhysicalLocation
		{ after(grammarAccess.getLocationSettingsMapEntryAccess().getValuePhysicalLocationParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DistanceSettingsMapEntry__KeyAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDistanceSettingsMapEntryAccess().getKeyDistanceCrossReference_0_0()); }
		(
			{ before(grammarAccess.getDistanceSettingsMapEntryAccess().getKeyDistanceIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getDistanceSettingsMapEntryAccess().getKeyDistanceIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getDistanceSettingsMapEntryAccess().getKeyDistanceCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DistanceSettingsMapEntry__ValueAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDistanceSettingsMapEntryAccess().getValueExpressionParserRuleCall_2_0()); }
		ruleExpression
		{ after(grammarAccess.getDistanceSettingsMapEntryAccess().getValueExpressionParserRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__TimingSettingsMapEntry__KeyAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getTimingSettingsMapEntryAccess().getKeyActionTypeCrossReference_0_0()); }
		(
			{ before(grammarAccess.getTimingSettingsMapEntryAccess().getKeyActionTypeIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getTimingSettingsMapEntryAccess().getKeyActionTypeIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getTimingSettingsMapEntryAccess().getKeyActionTypeCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__TimingSettingsMapEntry__ValueAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getTimingSettingsMapEntryAccess().getValueTimingParserRuleCall_2_0()); }
		ruleTiming
		{ after(grammarAccess.getTimingSettingsMapEntryAccess().getValueTimingParserRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__MotionProfileAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMotionProfileSettingsAccess().getMotionProfileIDTerminalRuleCall_1_0()); }
		RULE_ID
		{ after(grammarAccess.getMotionProfileSettingsAccess().getMotionProfileIDTerminalRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__MotionArgumentsAssignment_3_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMotionProfileSettingsAccess().getMotionArgumentsMotionArgumentsMapEntryParserRuleCall_3_0_0()); }
		ruleMotionArgumentsMapEntry
		{ after(grammarAccess.getMotionProfileSettingsAccess().getMotionArgumentsMotionArgumentsMapEntryParserRuleCall_3_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionProfileSettings__MotionArgumentsAssignment_3_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMotionProfileSettingsAccess().getMotionArgumentsMotionArgumentsMapEntryParserRuleCall_3_1_1_0()); }
		ruleMotionArgumentsMapEntry
		{ after(grammarAccess.getMotionProfileSettingsAccess().getMotionArgumentsMotionArgumentsMapEntryParserRuleCall_3_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionArgumentsMapEntry__KeyAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMotionArgumentsMapEntryAccess().getKeyIDTerminalRuleCall_0_0()); }
		RULE_ID
		{ after(grammarAccess.getMotionArgumentsMapEntryAccess().getKeyIDTerminalRuleCall_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__MotionArgumentsMapEntry__ValueAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMotionArgumentsMapEntryAccess().getValueExpressionParserRuleCall_2_0()); }
		ruleExpression
		{ after(grammarAccess.getMotionArgumentsMapEntryAccess().getValueExpressionParserRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__DefaultExpAssignment_0_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPhysicalLocationAccess().getDefaultExpExpressionParserRuleCall_0_1_0()); }
		ruleExpression
		{ after(grammarAccess.getPhysicalLocationAccess().getDefaultExpExpressionParserRuleCall_0_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__MinExpAssignment_1_1_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPhysicalLocationAccess().getMinExpExpressionParserRuleCall_1_1_2_0()); }
		ruleExpression
		{ after(grammarAccess.getPhysicalLocationAccess().getMinExpExpressionParserRuleCall_1_1_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__MaxExpAssignment_1_2_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPhysicalLocationAccess().getMaxExpExpressionParserRuleCall_1_2_2_0()); }
		ruleExpression
		{ after(grammarAccess.getPhysicalLocationAccess().getMaxExpExpressionParserRuleCall_1_2_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PhysicalLocation__DefaultExpAssignment_1_5
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPhysicalLocationAccess().getDefaultExpExpressionParserRuleCall_1_5_0()); }
		ruleExpression
		{ after(grammarAccess.getPhysicalLocationAccess().getDefaultExpExpressionParserRuleCall_1_5_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FixedValue__ValueExpAssignment
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFixedValueAccess().getValueExpExpressionParserRuleCall_0()); }
		ruleExpression
		{ after(grammarAccess.getFixedValueAccess().getValueExpExpressionParserRuleCall_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Array__ValuesExpAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getArrayAccess().getValuesExpExpressionParserRuleCall_2_0()); }
		ruleExpression
		{ after(grammarAccess.getArrayAccess().getValuesExpExpressionParserRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Array__ValuesExpAssignment_3_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getArrayAccess().getValuesExpExpressionParserRuleCall_3_1_0()); }
		ruleExpression
		{ after(grammarAccess.getArrayAccess().getValuesExpExpressionParserRuleCall_3_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__MinExpAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getTriangularDistributionAccess().getMinExpExpressionParserRuleCall_4_0()); }
		ruleExpression
		{ after(grammarAccess.getTriangularDistributionAccess().getMinExpExpressionParserRuleCall_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__MaxExpAssignment_8
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getTriangularDistributionAccess().getMaxExpExpressionParserRuleCall_8_0()); }
		ruleExpression
		{ after(grammarAccess.getTriangularDistributionAccess().getMaxExpExpressionParserRuleCall_8_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__ModeExpAssignment_12
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getTriangularDistributionAccess().getModeExpExpressionParserRuleCall_12_0()); }
		ruleExpression
		{ after(grammarAccess.getTriangularDistributionAccess().getModeExpExpressionParserRuleCall_12_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__TriangularDistribution__DefaultExpAssignment_13_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getTriangularDistributionAccess().getDefaultExpExpressionParserRuleCall_13_3_0()); }
		ruleExpression
		{ after(grammarAccess.getTriangularDistributionAccess().getDefaultExpExpressionParserRuleCall_13_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__MinExpAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPertDistributionAccess().getMinExpExpressionParserRuleCall_4_0()); }
		ruleExpression
		{ after(grammarAccess.getPertDistributionAccess().getMinExpExpressionParserRuleCall_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__MaxExpAssignment_8
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPertDistributionAccess().getMaxExpExpressionParserRuleCall_8_0()); }
		ruleExpression
		{ after(grammarAccess.getPertDistributionAccess().getMaxExpExpressionParserRuleCall_8_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__ModeExpAssignment_12
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPertDistributionAccess().getModeExpExpressionParserRuleCall_12_0()); }
		ruleExpression
		{ after(grammarAccess.getPertDistributionAccess().getModeExpExpressionParserRuleCall_12_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__GammaExpAssignment_16
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPertDistributionAccess().getGammaExpExpressionParserRuleCall_16_0()); }
		ruleExpression
		{ after(grammarAccess.getPertDistributionAccess().getGammaExpExpressionParserRuleCall_16_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PertDistribution__DefaultExpAssignment_17_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPertDistributionAccess().getDefaultExpExpressionParserRuleCall_17_3_0()); }
		ruleExpression
		{ after(grammarAccess.getPertDistributionAccess().getDefaultExpExpressionParserRuleCall_17_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__MeanExpAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getNormalDistributionAccess().getMeanExpExpressionParserRuleCall_4_0()); }
		ruleExpression
		{ after(grammarAccess.getNormalDistributionAccess().getMeanExpExpressionParserRuleCall_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__SdExpAssignment_8
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getNormalDistributionAccess().getSdExpExpressionParserRuleCall_8_0()); }
		ruleExpression
		{ after(grammarAccess.getNormalDistributionAccess().getSdExpExpressionParserRuleCall_8_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__NormalDistribution__DefaultExpAssignment_9_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getNormalDistributionAccess().getDefaultExpExpressionParserRuleCall_9_3_0()); }
		ruleExpression
		{ after(grammarAccess.getNormalDistributionAccess().getDefaultExpExpressionParserRuleCall_9_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__ValuesExpAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumeratedDistributionAccess().getValuesExpExpressionParserRuleCall_2_0()); }
		ruleExpression
		{ after(grammarAccess.getEnumeratedDistributionAccess().getValuesExpExpressionParserRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__ValuesExpAssignment_3_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumeratedDistributionAccess().getValuesExpExpressionParserRuleCall_3_1_0()); }
		ruleExpression
		{ after(grammarAccess.getEnumeratedDistributionAccess().getValuesExpExpressionParserRuleCall_3_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumeratedDistribution__DefaultExpAssignment_4_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumeratedDistributionAccess().getDefaultExpExpressionParserRuleCall_4_3_0()); }
		ruleExpression
		{ after(grammarAccess.getEnumeratedDistributionAccess().getDefaultExpExpressionParserRuleCall_4_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Declaration__NameAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDeclarationAccess().getNameIDTerminalRuleCall_2_0()); }
		RULE_ID
		{ after(grammarAccess.getDeclarationAccess().getNameIDTerminalRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Declaration__ExpressionAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDeclarationAccess().getExpressionExpressionParserRuleCall_4_0()); }
		ruleExpression
		{ after(grammarAccess.getDeclarationAccess().getExpressionExpressionParserRuleCall_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__PlusOrMinus__RightAssignment_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getPlusOrMinusAccess().getRightMulOrDivParserRuleCall_1_1_0()); }
		ruleMulOrDiv
		{ after(grammarAccess.getPlusOrMinusAccess().getRightMulOrDivParserRuleCall_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__MulOrDiv__RightAssignment_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMulOrDivAccess().getRightPrimaryParserRuleCall_1_1_0()); }
		rulePrimary
		{ after(grammarAccess.getMulOrDivAccess().getRightPrimaryParserRuleCall_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Atomic__ValueAssignment_0_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getAtomicAccess().getValueEBigDecimalParserRuleCall_0_1_0()); }
		ruleEBigDecimal
		{ after(grammarAccess.getAtomicAccess().getValueEBigDecimalParserRuleCall_0_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Atomic__DeclarationAssignment_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getAtomicAccess().getDeclarationDeclarationCrossReference_1_1_0()); }
		(
			{ before(grammarAccess.getAtomicAccess().getDeclarationDeclarationIDTerminalRuleCall_1_1_0_1()); }
			RULE_ID
			{ after(grammarAccess.getAtomicAccess().getDeclarationDeclarationIDTerminalRuleCall_1_1_0_1()); }
		)
		{ after(grammarAccess.getAtomicAccess().getDeclarationDeclarationCrossReference_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

RULE_ID : '^'? ('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;

RULE_INT : ('0'..'9')+;

RULE_STRING : ('"' ('\\' .|~(('\\'|'"')))* '"'|'\'' ('\\' .|~(('\\'|'\'')))* '\'');

RULE_ML_COMMENT : '/*' ( options {greedy=false;} : . )*'*/';

RULE_SL_COMMENT : '//' ~(('\n'|'\r'))* ('\r'? '\n')?;

RULE_WS : (' '|'\t'|'\r'|'\n')+;

RULE_ANY_OTHER : .;
